/*
 * Copyright (c) 2004-2011 StreamBase Systems, Inc.  All rights reserved.
 * Author: Darach Ennis <darach.ennis@streambase.com>
 *
 */
package com.streambase.demos.nvidia.bsm;

import java.nio.ByteBuffer;

public class AsyncBsm {
    static {
        boolean libAsyncBsmIsLoaded = false;
        try {
            if (!libAsyncBsmIsLoaded) {
                System.loadLibrary("AsyncBsm");
                libAsyncBsmIsLoaded = true;
            }
        } catch(UnsatisfiedLinkError ignoreAndContinue) {
        	// StreamBase Studio (Eclipse) may erroneously throw an ULE
        }
    }

    private long nativePtrMap;
    private float volatility = 0.06f;
    private float riskFree = .1f;
    private int optionMicroBatchSize = 100000;

    public AsyncBsm(int optionMicroBatchSize) {
        this.optionMicroBatchSize = optionMicroBatchSize;
    }

    public native void initCuda();
    public native void send(ByteBuffer buffer);
    public native boolean available();
    public native ByteBuffer receive();
    public native void freeCuda();

    public int getOptionMicroBatchSize() {
        return optionMicroBatchSize;
    }

    public void setRiskFreeRate(double riskFreeRate) {
        riskFreeRate = (float)riskFreeRate; // LOSES PRECISION
    }

    public void setVolatility(double volatility2) {
        volatility = (float)volatility2; // LOSES PRECISION
    }
}
